#include "iodefine.h"
#include "dma_ctrl.h"
#ifdef USE_CHECK
#include "check.h"
#endif

#define MP3_FRAME_SIZE 1152
static int frame_buf[2][MP3_FRAME_SIZE];
static short* p;
static int size;
static int status;

void init_dma()
{
	DMAC.DMAOR.BIT.DME = 0;

	/* CH0 Dxō SRCSSIFւ̃f[^ */
	DMAC.CHCR0.BIT.DE = 0;

	DMAC.SAR0.LONG			= (unsigned long)&SRC0.SRCOD.LONG;	/* \[XAhXWX^ */
	DMAC.RSAR0.LONG			= (unsigned long)&SRC0.SRCOD.LONG;	/* [h\[XAhXWX^ */
	DMAC.DAR0.LONG			= (unsigned long)&SSIF2.SSIFTDR;	/* fXeBl[VAhXWX^ */
	DMAC.DMATCR0.LONG		= 1;	/* gXt@JEgWX^ */
	DMAC.RDMATCR0.LONG		= 1;	/* [hgXt@JEgWX^ */

	DMAC.CHCR0.BIT.TC		= 0;	/* gXt@JEg[h */
	DMAC.CHCR0.BIT.RLDSAR	= 1;	/* SAR[h@\ON/OFF:[h */
	DMAC.CHCR0.BIT.RLDDAR	= 0;	/* DAR[h@\ON/OFF */
//	DMAC.CHCR0.BIT.DAF		= 0;	/* fXeBl[VAhXŒ16oCg] */
//	DMAC.CHCR0.BIT.SAF		= 0;	/* \[XAhXŒ16oCg] */
//	DMAC.CHCR0.BIT.DO		= 0;	/* DMAI[o */
//	DMAC.CHCR0.BIT.TL		= 0;	/* gXt@Ghx */
	DMAC.CHCR0.BIT.TEMASK	= 1;	/* TEZbg}XN:~Ȃ(GhX) */
//	DMAC.CHCR0.BIT.HE		= 0;	/* n[tGhtO */
	DMAC.CHCR0.BIT.HIE		= 0;	/* n[tGhC^vgCl[u */
//	DMAC.CHCR0.BIT.AM		= 0;	/* ANmbW[h */
//	DMAC.CHCR0.BIT.AL		= 0;	/* ANmbWx */
	DMAC.CHCR0.BIT.DM		= 0;	/* fXeBl[VAhX[h */
	DMAC.CHCR0.BIT.SM		= 0;	/* \[XAhX[h */
	DMAC.CHCR0.BIT.RS		= 8;	/* \[XZNg:DMAg\[X */
//	DMAC.CHCR0.BIT.DL		= 0;	/* DREQx */
//	DMAC.CHCR0.BIT.DS		= 0;	/* DREQGbWZNg */
	DMAC.CHCR0.BIT.TB		= 0;	/* gXt@oX[h */
	DMAC.CHCR0.BIT.TS		= 2;	/* gXt@TCY:O[h */
	DMAC.CHCR0.BIT.IE		= 0;	/* C^vgCl[u */
//	DMAC.CHCR0.BIT.TE		= 0;	/* gXt@GhtO */
	DMAC.CHCR0.BIT.DE		= 1;	/* DMACl[u */

	DMAC.DMARS0.BIT.CH0MID	= 0x0a;	/* SSIF2 */
	DMAC.DMARS0.BIT.CH0RID	= 3;	/* SSIF2 */

	/* CH1 MADLIBfR[hobt@SRCւ̃f[^ */
	DMAC.CHCR1.BIT.DE = 0;

	DMAC.SAR1.LONG			= (unsigned long)frame_buf;	/* \[XAhXWX^ */
	DMAC.RSAR1.LONG			= (unsigned long)frame_buf;	/* [h\[XAhXWX^ */
	DMAC.DAR1.LONG			= (unsigned long)&SRC0.SRCID.LONG;	/* fXeBl[VAhXWX^ */
	DMAC.DMATCR1.LONG		= 2 * MP3_FRAME_SIZE;	/* gXt@JEgWX^ */
	DMAC.RDMATCR1.LONG		= 2 * MP3_FRAME_SIZE;	/* [hgXt@JEgWX^ */

	DMAC.CHCR1.BIT.TC		= 0;	/* gXt@JEg[h */
	DMAC.CHCR1.BIT.RLDSAR	= 1;	/* SAR[h@\ON/OFF:[h */
	DMAC.CHCR1.BIT.RLDDAR	= 0;	/* DAR[h@\ON/OFF */
//	DMAC.CHCR1.BIT.DAF		= 0;	/* fXeBl[VAhXŒ16oCg] */
//	DMAC.CHCR1.BIT.SAF		= 0;	/* \[XAhXŒ16oCg] */
////	DMAC.CHCR1.BIT.DO		= 0;	/* DMAI[o */
////	DMAC.CHCR1.BIT.TL		= 0;	/* gXt@Ghx */
	DMAC.CHCR1.BIT.TEMASK	= 1;	/* TEZbg}XN:~Ȃ(GhX) */
//	DMAC.CHCR1.BIT.HE		= 0;	/* n[tGhtO */
	DMAC.CHCR1.BIT.HIE		= 0;	/* n[tGhC^vgCl[u */
////	DMAC.CHCR1.BIT.AM		= 0;	/* ANmbW[h */
////	DMAC.CHCR1.BIT.AL		= 0;	/* ANmbWx */
	DMAC.CHCR1.BIT.DM		= 0;	/* fXeBl[VAhX[h */
	DMAC.CHCR1.BIT.SM		= 1;	/* \[XAhX[h: */
	DMAC.CHCR1.BIT.RS		= 8;	/* \[XZNg:DMAg\[X */
////	DMAC.CHCR1.BIT.DL		= 0;	/* DREQx */
////	DMAC.CHCR1.BIT.DS		= 0;	/* DREQGbWZNg */
	DMAC.CHCR1.BIT.TB		= 0;	/* gXt@oX[h */
	DMAC.CHCR1.BIT.TS		= 2;	/* gXt@TCY:O[h */
	DMAC.CHCR1.BIT.IE		= 0;	/* C^vgCl[u */
//	DMAC.CHCR1.BIT.TE		= 0;	/* gXt@GhtO */
	DMAC.CHCR1.BIT.DE		= 0;	/* DMACl[u */

	DMAC.DMARS0.BIT.CH1MID	= 0x10;	/* SRC0 */
	DMAC.DMARS0.BIT.CH1RID	= 1;	/* ̓f[^GveB */

	/* S`l */
	DMAC.DMAOR.BIT.CMS		= 0;	/* TCNX`[[hZNg */
	DMAC.DMAOR.BIT.PR		= 0;	/* vCIeB[h */
//	DMAC.DMAOR.BIT.AE		= 0;	/* AhXG[tO */
//	DMAC.DMAOR.BIT.NMIF		= 0;	/* NMItO */
	DMAC.DMAOR.BIT.DME		= 1;	/* DMA}X^Cl[u */

	status = 0;
	#ifdef USE_CHECK
	init_check();
	#endif
	return;
}

void dma1_buf_control(void)
{
	if(status == 0)
	{
		p = (short*)&frame_buf[0];
		status = 1;
	}
	else
	if(status == 1)
	{
		DMAC.DMATCR1.LONG = 2 * MP3_FRAME_SIZE;
		DMAC.CHCR1.BIT.DE = 1;
		p = (short*)&frame_buf[1];
		status = 2;
	}
	else
	if(status == 2)
	{
		while(DMAC.CHCR1.BIT.HE == 0)
		{
			#ifdef USE_CHECK
			check1_toggle()
			#endif
			;
			if(SSIF2.SSISR.BIT.TUIRQ)
				printf("2h")
			;
		}
		#ifdef USE_CHECK
		check2_toggle();
		#endif
		DMAC.CHCR1.BIT.HE = 0;
		p = (short*)&frame_buf[0];
		status = 3;
	}
	else
	if(status == 3)
	{
		while(DMAC.CHCR1.BIT.TE == 0)
		{
			#ifdef USE_CHECK
			check3_toggle()
			#endif
			;
			if(SSIF2.SSISR.BIT.TUIRQ)
				printf("2e")
			;
		}
		#ifdef USE_CHECK
		check4_toggle();
		#endif
		DMAC.CHCR1.BIT.TE = 0;
		p = (short*)&frame_buf[1];
		status = 2;
	}
	size = 0;
	return;
}

void dma1_buf_put(short sample_l, short sample_r)
{
	*p++ = sample_l;
	*p++ = sample_r;
	size++;
	return;
}

void dma1_start(void)
{
	DMAC.CHCR1.BIT.DE = 1;
	return;
}

void dma1_stop(void)
{
	DMAC.CHCR1.BIT.DE = 0;
	return;
}

void dma1_end(void)
{
	int n;

	if(status == 2)
	{
		while(DMAC.CHCR1.BIT.HE == 0)
		{
			;
		}
		DMAC.CHCR1.BIT.HE = 0;
		for(n = 0; n < MP3_FRAME_SIZE; n++)
		{
			frame_buf[0][n] = 0;
		}
		while(DMAC.CHCR1.BIT.TE == 0)
		{
			;
		}
		DMAC.CHCR1.BIT.TE = 0;
		while(DMAC.CHCR1.BIT.HE == 0)
		{
			;
		}
		DMAC.CHCR1.BIT.HE = 0;
		for(n = 0; n < MP3_FRAME_SIZE; n++)
		{
			frame_buf[1][n] = 0;
		}
		while(DMAC.CHCR1.BIT.TE == 0)
		{
			;
		}
		DMAC.CHCR1.BIT.TE = 0;
	}
	else
	if(status == 3)
	{
		while(DMAC.CHCR1.BIT.TE == 0)
		{
			;
		}
		DMAC.CHCR1.BIT.TE = 0;
		for(n = 0; n < MP3_FRAME_SIZE; n++)
		{
			frame_buf[1][n] = 0;
		}
		while(DMAC.CHCR1.BIT.HE == 0)
		{
			;
		}
		DMAC.CHCR1.BIT.HE = 0;
		while(DMAC.CHCR1.BIT.TE == 0)
		{
			;
		}
		DMAC.CHCR1.BIT.TE = 0;
	}
	status = 0;

	DMAC.CHCR1.BIT.DE = 0;
	return;
}
